      FUNCTION DKEPLR(M,E)
      SAVE ! REQUIRED FOR IRIX
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 M,PI2/6.283185307179586D0/,TOL/0.5D-15/
C
C SUBROUTINE TO SOLVE KEPLER'S EQUATION
C KEPLER'S EQUATION RELATES GEOMETRY OR POSITION IN ORBIT PLANE
C  TO TIME.
C
C  M - MEAN ANOMALY (O<M<2PI)
C  E - ECCENTRICITY
C  EA - ECCENTRIC ANOMALY
C
      EA=0
      IF(M)1,2,1
    1 EA=M + E*DSIN(M)
      DO 22 I=1,12
      OLDEA=EA
      FE=EA-E*DSIN(EA)-M
      EA=EA-FE/(1-E*DCOS(EA-0.5D0*FE))
C TEST FOR CONVERGENCE
      DELEA=DABS(EA-OLDEA)
      IF(DELEA.LE.TOL)GO TO 2
   22 CONTINUE
    2 EA=DMOD(EA,PI2)
      DKEPLR=EA
      RETURN
      END
C

