#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>

static char *months[] = {"Jan","Feb","Mar","Apr","May","Jun",
                         "Jul","Aug","Sep","Oct","Nov","Dec"};

static int monthname_to_int(unsigned char *monthname)
{
 int ret;

 for(ret=0; strncmp(months[ret],monthname,3) != 0; ret++);

 return(ret);
}


main(int argc, char **argv)
{
 extern int convert_day_of_year_to_day_of_month (int, int, unsigned char **, int *);
 struct tm mytime;
 time_t now;
 int iyear,idoy,oyear,odoy,hour,min,sec,msec,orbno,printit=0,mday;
 double xlat;
 unsigned char *mon;

  if (argc != 3) {  
     fprintf(stderr,"Usage %s year doy\n", argv[0]);
     exit(1);
    }
  else {
     sscanf(argv[1],"%d", &iyear);
     sscanf(argv[2],"%d", &idoy);
     bobdays_(&iyear,&idoy,&odoy,&hour,&min,&sec,&msec,
              &xlat,&orbno,&printit);
     oyear = (odoy > idoy) ? iyear-1 : iyear;
     printf("SFYR=%4d\n"
            "SDOY=%d\n"
            "STIM=%02d:%02d:%02d.%03d\n"
            "SSBT=%2d%03d%02d%02d%02d\n"
            "SLAT=%1.4f\n"
            "SORB=%d\n", oyear,odoy,hour,min,sec,
                         msec,oyear % 100,odoy,hour,min,sec,xlat,orbno);
     (void) convert_day_of_year_to_day_of_month(iyear, idoy, &mon, &mday);
     mytime.tm_year = iyear % 100;
     mytime.tm_mon = monthname_to_int(mon);
     mytime.tm_mday = mday + 1;
     mytime.tm_hour = 0;
     mytime.tm_min = 0;
     mytime.tm_sec = 0;
     mytime.tm_isdst = 0;
     (void) mktime(&mytime);
     iyear = mytime.tm_year + 1900;
     idoy = mytime.tm_yday + 1;
     bobdays_(&iyear,&idoy,&odoy,&hour,&min,&sec,&msec,
              &xlat,&orbno,&printit);
     oyear = (odoy > idoy) ? iyear-1 : iyear;
     printf("EFYR=%4d\n"
            "EDOY=%d\n"
            "ETIM=%02d:%02d:%02d.%03d\n"
            "ESBT=%2d%03d%02d%02d%02d\n"
            "ELAT=%1.4f\n"
            "EORB=%d\n", oyear,odoy,hour,min,sec,
                         msec,oyear % 100,odoy,hour,min,sec,xlat,orbno);
    }
    
}
