      subroutine selfilnm(myr,idoy,fnme)
c
c  Given year, day of year, returns appropriate file name for
c  daily orbit number data.
c
      character*80 fnme
      character cday1*1,cday2*2,cday3*3,cday*3,c1*1,cyr*2
      character*10 chead
      character*4 cdat
      character*1 zero
c
      chead = '$NORAD/sel'
      cdat = '.dat'
      zero = '0'
c
c  Convert day
      jday = idoy
      if (jday .lt. 10)then
       write(cday1,'(i1)')jday
       cday = zero//zero//cday1
      else if (jday .lt. 100)then
       write(cday2,'(i2)')jday
       cday = zero//cday2
      else
       write(cday3,'(i3)')jday
       cday = cday3
      endif
c
c  Convert year
      if (myr .le. 1999)then
       itmp = myr - 1900
       write(cyr,'(i2)')itmp
      else if (myr .eq. 2000)then
       cyr = zero//zero
      else if (myr .lt. 2010)then
       itmp = myr - 2000
       write(c1,'(i1)')itmp
       cyr = zero//c1
      else
       itmp = myr - 2000
       write(cyr,'(i2)')itmp
      endif
c
c  File name
      fnme = chead//cday//cyr//cdat
      call filenv(fnme,fnme)
c
      return
      end
